/* common functions for babicon and babicmd */
int infcon(char *host){
  int infsock;

  /* Connect to babild */
  if(!(infsock = mktcpsend(host, INFCOMPORT))){
    printf("babicon: Can't connet to babinfo.\n");
    exit(0);
    return 0;
  }
  
  return infsock;
}

int ebcon(char *host){
  int ebsock;

  /* Connect to babild */
  if(!(ebsock = mktcpsend(host, EBCOMPORT))){
    printf("babicon: Can't connet to babild.\n");
    exit(0);
    return 0;
  }
  
  return ebsock;
}

int chkcom(char *com, char **comlist){
  int ret = -1, i;

  i = 0;
  while(comlist[i]){
    if(!strcmp(com, comlist[i])){
      ret = i/3;
      break;
    }
    i += 3;
  }

  return ret;
}


int exec_psh(char *arg){
  FILE *pfp;
  char buff[1024];

  memset(buff, 0, sizeof(buff));

  if(strlen(arg) <= 0) return 0;

  if((pfp = popen(arg, "r")) == NULL){
    printf("Can't exec %s\n", arg);
    return 0;
  }else{
    fread(buff, 1, sizeof(buff)-1, pfp);
    if(pclose(pfp) < 0){
      printf("Unknown error : %s", arg);
      return 0;
    }
    printf("%s", buff);
    if(buff[0] == 'O' && buff[1] == 'K'){
      // OK
      return 1;
    }else{
      // Error
      return 0;
    }
  }
}

int exec_nsh(char *arg){
  char buff[1024];

  memset(buff, 0, sizeof(buff));
  sprintf(buff, "%s &", arg);
  system(buff);

  return 1;
}


int pstart(char *arg){
  if(strlen(arg) <= 0){
    printf("pstart COMMAND\n");
    return 0;
  }

  if(!exec_nsh(arg)){
    return 0;
  }else{
    start();
  }

  return 0;
}

int pnssta(char *arg){
  if(strlen(arg) <= 0){
    printf("pnssta COMMAND\n");
    return 0;
  }

  if(!exec_nsh(arg)){
    return 0;
  }else{
    nssta();
  }

  return 0;
}

int pstop(char *arg){
  if(strlen(arg) <= 0){
    printf("pstop COMMAND\n");
    return 0;
  }

  if(!exec_psh(arg)){
    return 0;
  }else{
    stop();
  }

  return 0;
}

int show_scrlive(void){
  printf("Scaler live time information\n");
  printf("   GATED id=%3d ch=%2d\n", scrlive.gatedid, scrlive.gatedch);
  printf(" UNGATED id=%3d ch=%2d\n", scrlive.ungatedid, scrlive.ungatedch);
  printf("\n");

  return 1;
}

int setscrlive(char *arg){
  char this[] = "setscrlive";
  int argc;
  char *argv[10];
  int sock, ret;
  int com, tid, tch;
  enum comlist {GATED, UNGATED};

  argc = striparg(arg, argv);

  if(argc != 3){
    synopsis(this);
    return 0;
  }


  ret = 0;
  
  if((com = chkcom(argv[0], comsetscrlive)) < 0){
    printf("Unknown command : %s \n", argv[1]);
    synopsis(this);
    return 0;
  }

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_SCRLIVE, (char *)&scrlive);
  close(sock);
  
  tid = strtol(argv[1], NULL, 0);
  tch = strtol(argv[2], NULL, 0);

  switch(com){
  case GATED:
    scrlive.gatedid = tid;
    scrlive.gatedch = tch;
    break;
  case UNGATED:
    scrlive.ungatedid = tid;
    scrlive.ungatedch = tch;
    break;
  }

  sock = infcon(ebhostname);
  ret = eb_set(sock, INF_SET_SCRLIVE, (char *)&scrlive,
	 sizeof(scrlive));
  close(sock);
  if(!ret){
    printf("setscrlive, faled\n");
  }

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_SCRLIVE, (char *)&scrlive);
  close(sock);

  show_scrlive();

  return 1;
}


int getscrlive(char *arg){
  int sock;

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_SCRLIVE, (char *)&scrlive);
  close(sock);

  show_scrlive();

  return 1;
}

void show_statcom(void){
  cprintf(FG_BLACK|BG_RED, "Run status command\n");
  printf("On/Off: %s\n", ofstr[statcom.of]);
  printf("Start : %s\n", statcom.start);
  printf("Stop  : %s\n", statcom.stop);
  printf("\n");
}

int setstatcom(char *arg){
  int sock, argc;
  char *argv[10];
  char this[] = "setstatcom";
  enum comlist {ON, OFF, START, STOP};
  char ch1[80];
  int ret;
  int com;
  char *line;

  argc = striparg(arg, argv);
  if(argc != 1 && argc != 2){
    synopsis(this);
    return 0;
  }

  ret = 0;

  if((com = chkcom(argv[0], comstatcom)) < 0){
    printf("Unknown command : %s \n", argv[1]);
    synopsis(this);
    return 0;
  }
  memset(ch1, 0, sizeof(ch1));
  switch(com){
  case START:
  case STOP:
      line = readline("PATH : ");
      strncpy(ch1, line, sizeof(ch1));
      free(line);
      break;
  }

  sock = ebcon(ebhostname);
  eb_get(sock, EB_GET_STAT_COMMAND, (char *)&statcom);
  close(sock);


  switch(com){
  case ON:
    statcom.of = 1;
    break;
  case OFF:
    statcom.of = 0;
    break;
  case START:
    strncpy(statcom.start, ch1, sizeof(ch1));
    break;
  case STOP:
    strncpy(statcom.stop, ch1, sizeof(ch1));
    break;
  }

  sock = ebcon(ebhostname);
  ret = eb_set(sock, EB_SET_STAT_COMMAND, (char *)&statcom, sizeof(statcom));
  close(sock);
  if(!ret){
    printf("Run is now running, can't change parameters\n");
  }

  sock = ebcon(ebhostname);
  eb_get(sock, EB_GET_STAT_COMMAND, (char *)&statcom);
  close(sock);

  show_statcom();

  return 1;
}

int getstatcom(char *arg){
  int sock;

  sock = ebcon(ebhostname);
  eb_get(sock, EB_GET_STAT_COMMAND, (char *)&statcom);
  close(sock);
  show_statcom();

  return 1;
}

int gettcpclinfo(char *arg){
  int sock;

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_TCPCLIHOSTS, (char *)&tcpclinfo);
  close(sock);
  show_tcpclinfo();

  return 1;
}


// DB connection
void show_dbcon(void){
  cprintf(FG_BLACK|BG_MAGENTA, "DB connection\n");
  printf("On/Off : %s\n", ofstr[dbcon.of]);
  printf("DBHost : %s\n", dbcon.host);
  printf("DBName : %s\n", dbcon.dbname);
  printf("DBUser : %s\n", dbcon.user);
  printf("DBPass : *******\n");
  printf("\n");
}

int setdbcon(char *arg){
  int sock, argc;
  char *argv[10];
  char this[] = "setdbcon";
  enum comlist {ON, OFF, SET};
  char ch1[80], ch2[80], ch3[80], ch4[80], prop[80];
  int ret;
  int com;
  char *line;

  argc = striparg(arg, argv);
  if(argc != 1 && argc != 5){
    synopsis(this);
    return 0;
  }

  ret = 0;

  if((com = chkcom(argv[0], comdbcon)) < 0){
    printf("Unknown command : %s \n", argv[1]);
    synopsis(this);
    return 0;
  }

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_DBCON, (char *)&dbcon);
  close(sock);

  memset(ch1, 0, sizeof(ch1));
  memset(ch2, 0, sizeof(ch2));
  memset(ch3, 0, sizeof(ch3));
  memset(ch4, 0, sizeof(ch4));

  switch(com){
  case SET:
    if(argc == 1){
      sprintf(prop, "HOST [def=%s] : ", dbcon.host);
      line = readline(prop);
      strncpy(ch1, line, sizeof(ch1));
      free(line);

      sprintf(prop, "DBNAME [def=%s] : ", dbcon.dbname);
      line = readline(prop);
      strncpy(ch2, line, sizeof(ch2));
      free(line);

      sprintf(prop, "DBUSER [def=%s] : ", dbcon.user);
      line = readline(prop);
      strncpy(ch3, line, sizeof(ch3));
      free(line);

      sprintf(prop, "DBPASS [def=*****] : ");
      line = readline(prop);
      strncpy(ch4, line, sizeof(ch4));
      free(line);
    }else{
      strncpy(ch1, argv[2], sizeof(ch1));
      strncpy(ch2, argv[3], sizeof(ch2));
      strncpy(ch3, argv[4], sizeof(ch3));
      strncpy(ch4, argv[5], sizeof(ch4));
    }
    break;
  }


  switch(com){
  case ON:
    dbcon.of = 1;
    break;
  case OFF:
    dbcon.of = 0;
    break;
  case SET:
    if(strlen(ch1) > 1){
      strncpy(dbcon.host, ch1, sizeof(ch1));
    }
    if(strlen(ch2) > 1){
      strncpy(dbcon.dbname, ch2, sizeof(ch2));
    }
    if(strlen(ch3) > 1){
      strncpy(dbcon.user, ch3, sizeof(ch3));
    }
    if(strlen(ch4) > 1){
      strncpy(dbcon.passwd, ch4, sizeof(ch4));
    }
    break;
  }

  sock = infcon(ebhostname);
  ret = eb_set(sock, INF_SET_DBCON, (char *)&dbcon, sizeof(dbcon));
  close(sock);

  if(!ret){
    printf("Run is now running, can't change parameters\n");
  }

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_DBCON, (char *)&dbcon);
  close(sock);

  show_dbcon();

  return 1;
}

int getdbcon(char *arg){
  int sock;

  sock = infcon(ebhostname);
  eb_get(sock, INF_GET_DBCON, (char *)&dbcon);
  close(sock);

  show_dbcon();

  return 1;
}

int chkdbcon(char *arg){
  int sock, ret;

  sock = infcon(ebhostname);
  eb_get(sock, INF_CHK_DBCON, (char *)&ret);
  close(sock);

  if(ret){
    cprintf(FG_BLUE, "Connection OK\n");
  }else{
    cprintf(FG_MAGENTA, "Connection NG\n");
  }

  return 1;
}

void show_clinfo(void){
  int i;
  cprintf(FG_BLACK|BG_CYAN, "UDP Client list\n");
  printf("ID  : HOSTNAME\n");
  for(i=0;i<MAXCLI;i++){
    if(clinfo[i].ex){
      printf("%3d : %s (SHMID = %d)\n", i, clinfo[i].clihost, clinfo[i].ex-1);
    }
  }
}


void show_tcpclinfo(void){
  int i;
  cprintf(FG_BLACK|BG_CYAN, "TCP Client list\n");
  printf("ID  : HOSTNAME\n");
  for(i=0;i<MAXTCPCLI;i++){
    if(tcpclinfo[i].sock){
      printf("%3d : %s (port = %d)\n", i, tcpclinfo[i].host, tcpclinfo[i].port);
    }
  }
}

