void map(void){

  univ_init_window(LUPOADDR, REGSIZE, A32, LUPOMAPN);
  univ_init_window(QDC1ADDR, REGSIZE, A32, QDC1MAPN);
  univ_init_window(QDC2ADDR, REGSIZE, A32, QDC2MAPN);
  //univ_init_dma(QDC1ADDR, DMASIZE, QDC1MAPN);
  //univ_init_dma(QDC2ADDR, DMASIZE, QDC2MAPN);
  univ_init_dma(MCSTADDR, DMASIZE, MCSTMAPN);
}


void startup(void){
  short val;
  /* Startup Function */

  vme_define_intlevel(INTLEVEL);

  // Interrupt delay 20ns step
  val = 1000; // 20us; 
  vlupoio_intdelay_map(LUPOMAPN, val);

  v792_map_clear(QDC1MAPN);
  v792_map_clear(QDC2MAPN);

  //val = 0x0020;  // Bus Error Enable
  val = 0x0000;    // Buss Error Disable
  univ_map_write16(0x1010, &val, QDC1MAPN);
  univ_map_write16(0x1010, &val, QDC2MAPN);

  val = 0x00aa;    // MSCT Adress=0xaa
  univ_map_write16(0x1004, &val, QDC1MAPN);
  univ_map_write16(0x1004, &val, QDC2MAPN);

  val = 0x01; // Last Board
  univ_map_write16(0x101a, &val, QDC1MAPN);
  val = 0x02; // First Board
  univ_map_write16(0x101a, &val, QDC2MAPN);

  vlupoio_clear_map(LUPOMAPN);
  vlupoio_enable_interrupt_map(LUPOMAPN);
  vlupoio_pulse_map(LUPOMAPN, OPCLEAR);

}
