#include "vlupo.h"

int vlupoio_nimin_segdata_map(int n){

  univ_map_read16(VLUPO_IO_NIMIN, (short *)(data+mp), n);
  mp +=1;
  segmentsize +=1;

  return segmentsize;
}

int vlupoio_nimcoin_segdata_map(int n){

  univ_map_read16(VLUPO_IO_NIMCOIN, (short *)(data+mp), n);
  mp += 1;
  segmentsize += 1;

  return segmentsize;
}

int vlupoio_lvdsin_segdata_map(int n){

  univ_map_read16(VLUPO_IO_LVDSIN, (short *)(data+mp), n);
  mp += 1;
  segmentsize += 1;

  return segmentsize;
}

int vlupoio_lvdscoin_segdata_map(int n){

  univ_map_read16(VLUPO_IO_LVDSCOIN, (short *)(data+mp), n);
  mp += 1;
  segmentsize += 1;

  return segmentsize;
}

void vlupoio_clear_map(int n){
  short val;

  univ_map_read16(VLUPO_IO_CLEAR, &val, n);
}

void vlupoio_enable_interrupt_map(int n){
  short val = 1;

  univ_map_write16(VLUPO_IO_INTENABLE, &val, n);

}

void vlupoio_disable_interrupt_map(int n){
  short val = 1;

  univ_map_write16(VLUPO_IO_INTDISABLE, &val, n);

}

void vlupoio_pulse_map(int n, short val){

  univ_map_write16(VLUPO_IO_PULSE, &val, n);
}

void vlupoio_level_map(int n, short val){

  univ_map_write16(VLUPO_IO_LEVEL, &val, n);
}

void vlupoio_intdelay_map(int n, short val){

  univ_map_write16(VLUPO_IO_INTDELAY, &val, n);
}

void vlupoio_pulsewidth_map(int n, short val){

  univ_map_write16(VLUPO_IO_PULSEWIDTH, &val, n);
}

int vlupotrg_clk_map(int n){
  univ_map_read32(0x00, (long *)(data+mp), n);
  mp += 2;
  univ_map_read32(0x04, (long *)(data+mp), n);
  mp += 2;

  segmentsize += 4;

  return segmentsize;
}

int vlupots_segts_map(int n){

  univ_map_read32(VLUPO_TS_DATA32L, (long *)(data+mp), n);
  mp += 2;
  univ_map_read32(VLUPO_TS_DATA32H, (long *)(data+mp), n);
  mp += 1;
  segmentsize += 3;
  
  memcpy((char *)&timestamp , (char *)(data+mp-3), 8);
  
  
  return segmentsize;
}

int vlupots_segtsfly_map(int n){
  univ_map_read32(VLUPO_TS_DATAFLY, (long *)(data+mp), n);
  mp += 2;
  segmentsize += 2;

  return segmentsize;
}

void vlupots_intdelay_map(int n, short val){

  univ_map_write16(VLUPO_TS_INTDELAY, &val, n);
}

void vlupots_pulse_map(int n, short val){

  univ_map_write16(VLUPO_TS_PULSE, &val, n);
}

void vlupots_pulsewidth_map(int n, short val){

  univ_map_write16(VLUPO_TS_PULSEWIDTH, &val, n);
}

void vlupots_clear_map(int n){
  short val = 1;

  univ_map_read16(VLUPO_TS_CLEAR, &val, n);
}

void vlupots_clear_counter_map(int n){
  short val = 1;

  univ_map_read16(VLUPO_TS_CLEARCOUNTER, &val, n);
}

int vlupots_segfifocnt_map(int n){
   long lval;
   
   univ_map_read32(VLUPO_TS_FIFOCNT, &lval, n);
  data[mp] = lval & 0x0000ffff;
  mp ++;
  segmentsize ++;

  return segmentsize;
}

int vlupots_segtrgcnt_map(int n){
   
   univ_map_read32(VLUPO_TS_TRGCOUNTER, (long *)(data+mp), n);
  mp +=2;
  segmentsize +=2;

  return segmentsize;
}

void vlupots_clkmode_map(int n, short val){

  univ_map_write16(VLUPO_TS_CLKMODE, &val, n);
}


void vlupots_enable_interrupt_map(int n){
  short val = 1;

  univ_map_write16(VLUPO_TS_INTENABLE, &val, n);

}

void vlupots_disable_interrupt_map(int n){
  short val = 1;

  univ_map_write16(VLUPO_TS_INTDISABLE, &val, n);

}
