/* babinfodb.c
 * last modified : 11/10/09 17:03:36 
 * Hidetada Baba (RIKEN)
 *
 * Functions for connection to DB
 *
 */

#include <stdio.h>
#include <string.h>
#include <time.h>

#include <bi-config.h>
#include <bi-common.h>

#include <bbpsql.h>
#include "babinfodb.h"

char *runstatstr[3] =  {"IDLE\0", "START\0", "NSSTA\0"};

int babinfodb_connect(struct stdbcon dbcon){
  if(!bbpsql_connect(dbcon.host, dbcon.dbname, dbcon.user, dbcon.passwd)){
    return 0;
  }

  return 1;
}


int babinfodb_chkconnect(struct stdbcon dbcon){
  if(!babinfodb_connect(dbcon)){
    return 0;
  }
  bbpsql_end();

  return 1;
}


int babinfodb_runstart(struct stdbcon dbcon, struct stdaqinfo *daqinfo,
		       struct struninfo *runinfo){
  char sql[1024];

  if(!babinfodb_connect(dbcon)){
    return 0;
  }

  sql_insert_run(daqinfo, runinfo, sql);

  DB(printf("Run Start SQL = %s\n", sql));
  bbpsql_sql_noresult(sql);
  bbpsql_end();

  
  return 1;
}

int babinfodb_runstop(struct stdbcon dbcon, struct stdaqinfo *daqinfo,
		      struct struninfo *runinfo){


  char sql[1024];

  if(!babinfodb_connect(dbcon)){
    return 0;
  }

  sql_update_run_stop(daqinfo, runinfo, sql);

  DB(printf("Run Stop SQL = %s\n", sql));
  bbpsql_sql_noresult(sql);
  bbpsql_end();

  return 1;
}


void sql_insert_run(struct stdaqinfo *daqinfo,
		    struct struninfo *runinfo, char *sql){
  int idx = 0;
  char tdate[256];
  char sheader[1024];

  strncpy(sheader, runinfo->header, sizeof(sheader));
  bbpsql_safetext(sheader, strlen(sheader));

  int2date(runinfo->starttime, tdate);

  idx = sprintf(sql, "INSERT INTO \"Run\"(\"Name\", ");
  idx += sprintf(sql+idx, "\"Number\", \"Status\", \"StartDate\", ");
  idx += sprintf(sql+idx, "\"Header\") VALUES(");
  idx += sprintf(sql+idx, "'%s', ", daqinfo->runname);
  idx += sprintf(sql+idx, "'%d', ", daqinfo->runnumber);
  idx += sprintf(sql+idx, "'%s', ", runstatstr[runinfo->runstat]);
  idx += sprintf(sql+idx, "'%s', ", tdate);
  idx += sprintf(sql+idx, "'%s')", sheader);
}

void sql_update_run_stop(struct stdaqinfo *daqinfo,
		    struct struninfo *runinfo, char *sql){
  int idx = 0;
  char tdate[256];
  char sender[1024];

  strncpy(sender, runinfo->ender, sizeof(sender));
  bbpsql_safetext(sender, strlen(sender));

  int2date(runinfo->stoptime, tdate);

  idx = sprintf(sql, "UPDATE \"Run\" SET ");
  idx += sprintf(sql+idx, "\"Status\" = 'STOP', ");
  idx += sprintf(sql+idx, "\"StopDate\" = '%s', ", tdate);
  idx += sprintf(sql+idx, "\"Ender\" = '%s' "   , sender);
  idx += sprintf(sql+idx, "WHERE \"Number\" = '%d' ", daqinfo->runnumber);
  idx += sprintf(sql+idx, "AND \"Name\" = '%s' ", daqinfo->runname);
  idx += sprintf(sql+idx, "AND \"Status\" != 'STOP'");
}

void int2date(int t, char *tdate){
  struct tm *date;
  time_t tt;

  tt = t;

  date = localtime(&tt);
  sprintf(tdate, "%04d-%02d-%02d %02d:%02d:%02d",
	  date->tm_year+1900, date->tm_mon+1, date->tm_mday,
	  date->tm_hour, date->tm_min, date->tm_sec);
}
