/*
 * last modified : 12/06/06 17:18:06 
 * babirl/babissm/gtossm.c
 * 
 * front-end for xport mssm module
 *
 * gtossm HOSTNAME on/off
 *
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <libbabirl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

const int MAXTRY = 200;

int main(int argc, char *argv[]){
  int sock = 0, try = 0, size = 4;
  char of[64];

  if(argc < 3){
    printf("gtossm HOSTNAME on/off/com/noop\n");
    exit(0);
  }

  sprintf(of, "!!0Z");
  if(!strcmp(argv[2], "off")){
    sprintf(of, "!!0z");
  }else if(!strcmp(argv[2], "com")){
    size = snprintf(of, sizeof(of), "!!%s", argv[3]);
  }else if(!strcmp(argv[2], "noop")){
    size = snprintf(of, sizeof(of), "!!");
  }

  while(!sock){
    sock = mktcpsend(argv[1], 10001);
    try++;
    if(try > MAXTRY) break;
    usleep(50000); // 50ms * 200 = 10s
  }

  if(!sock){
    printf("Can't connect %s\n", argv[1]);
    exit(1);
  }
  send(sock, of, size, 0);
  close(sock);

  return 0;
}
