/* bbpsql.c
 * last modified : 11/10/19 17:10:25 
 *
 * Library for PostgreSQL access
 *
 */

#include <stdio.h>
#include <string.h>

#include <bbpsql.h>

/* macros */
#ifdef DEBUG
#define DB(x) x
#else
#define DB(x)
#endif

static char conninfo[1024];
static PGconn *conn;

int bbpsql_connect(char *host, char *dbname, char *user, char *passwd){
  memset(conninfo, 0, sizeof(conninfo));
  sprintf(conninfo, "host=%s dbname=%s user=%s password=%s",
	  host, dbname, user, passwd);
  DB(printf("Parameters : %s\n", conninfo));

  conn = PQconnectdb(conninfo);
  DB(printf("Status : %d\n", PQstatus(conn)));
  if(PQstatus(conn) == CONNECTION_BAD){
    return 0;
  }
  
  return 1;
}

int bbpsql_end(void){
  PQfinish(conn);

  return 1;
}


int bbpsql_sql(char *sql, PGresult **res){
  *res = PQexec(conn, sql);

  if(!res || PQresultStatus(*res) == PGRES_FATAL_ERROR){
    return 0;
  }

  return 1;
}

int bbpsql_sql_noresult(char *sql){
  PQexec(conn, sql);

  return 1;
}

int bbpsql_clear_result(PGresult *res){
  PQclear(res);

  return 1;
}

int bbpsql_get_oneresult(PGresult *res, char *ret){

  if(PQnfields(res) && PQntuples(res)){
    sprintf(ret, "%s", PQgetvalue(res, 0, 0));
  }else{
    sprintf(ret, "No Result");
    return 0;
  }

  return 1;
}

void bbpsql_safetext(char *test, int len){
  int i;

  for(i=0;i<len;i++){
    if(test[i] == '\"' || test[i] == '\''
       || test[i] == '\n' || test[i] == '\r'){
      test[i] = ' ';
    }
  }
}
